package com.zt.plat.module.qms.resource.device.controller.admin;

import com.alibaba.fastjson.JSONObject;
import com.zt.plat.module.qms.resource.device.controller.vo.*;
import org.springframework.web.bind.annotation.*;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.security.access.prepost.PreAuthorize;
import com.zt.plat.framework.business.interceptor.BusinessControllerMarker;
import com.zt.plat.framework.business.annotation.FileUploadController;
import com.zt.plat.framework.business.controller.AbstractFileUploadController;

import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Operation;

import jakarta.validation.*;
import jakarta.servlet.http.*;
import java.util.*;
import java.io.IOException;

import com.zt.plat.framework.common.pojo.vo.BatchDeleteReqVO;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.framework.datapermission.core.annotation.DeptDataPermissionIgnore;

import static com.zt.plat.framework.common.pojo.CommonResult.success;

import com.zt.plat.framework.excel.core.util.ExcelUtils;

import com.zt.plat.framework.apilog.core.annotation.ApiAccessLog;
import static com.zt.plat.framework.apilog.core.enums.OperateTypeEnum.*;

import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceCalibrationPlanDO;
import com.zt.plat.module.qms.resource.device.service.DeviceCalibrationPlanService;

@Tag(name = "管理后台 - 设备-检定校准计划")
@RestController
@RequestMapping("/qms/resource/device-calibration-plan")
@Validated
@DeptDataPermissionIgnore(enable = "true")
@FileUploadController(source = "qms.devicecalibrationplan")
public class DeviceCalibrationPlanController extends AbstractFileUploadController implements BusinessControllerMarker{

    static {
        FileUploadController annotation = DeviceCalibrationPlanController.class.getAnnotation(FileUploadController.class);
        if (annotation != null) {
        setFileUploadInfo(annotation);
        }
    }

    @Resource
    private DeviceCalibrationPlanService deviceCalibrationPlanService;

    @PostMapping("/createPlan")
    @Operation(summary = "创建设备-检定校准计划")
    public CommonResult<DeviceCalibrationPlanRespVO> createPlan(@RequestBody JSONObject param) {
        String checkYear = param.getString("checkYear");
        return deviceCalibrationPlanService.createPlan(checkYear);
    }

    @RequestMapping("/savePlan")
    @Operation(summary = "编辑计划")
    public CommonResult<DeviceCalibrationPlanRespVO> savePlan(@RequestBody DeviceCalibrationPlanSaveReqVO param) {
        return deviceCalibrationPlanService.savePlan(param);
    }

    @RequestMapping("/submitApply")
    @Operation(summary = "提交申请")
    public CommonResult<DeviceCalibrationPlanRespVO> submitApply(@RequestBody DeviceCalibrationPlanSaveReqVO param) {
        return deviceCalibrationPlanService.submitApply(param);
    }

    @PutMapping("/update")
    @Operation(summary = "更新设备-检定校准计划")
    public CommonResult<Boolean> updateDeviceCalibrationPlan(@Valid @RequestBody DeviceCalibrationPlanSaveReqVO updateReqVO) {
        deviceCalibrationPlanService.updateDeviceCalibrationPlan(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除设备-检定校准计划")
    @Parameter(name = "id", description = "编号", required = true)
    public CommonResult<Boolean> deleteDeviceCalibrationPlan(@RequestParam("id") Long id) {
        deviceCalibrationPlanService.deleteDeviceCalibrationPlan(id);
        return success(true);
    }

    @DeleteMapping("/delete-list")
    @Parameter(name = "ids", description = "编号", required = true)
    @Operation(summary = "批量删除设备-检定校准计划")
                @PreAuthorize("@ss.hasPermission('qms:device-calibration-plan:delete')")
    public CommonResult<Boolean> deleteDeviceCalibrationPlanList(@RequestBody BatchDeleteReqVO req) {
        deviceCalibrationPlanService.deleteDeviceCalibrationPlanListByIds(req.getIds());
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得设备-检定校准计划")
    @Parameter(name = "id", description = "编号", required = true, example = "1024")
    public CommonResult<DeviceCalibrationPlanRespVO> getDeviceCalibrationPlan(@RequestParam("id") Long id) {
        DeviceCalibrationPlanDO deviceCalibrationPlan = deviceCalibrationPlanService.getDeviceCalibrationPlan(id);
        return success(BeanUtils.toBean(deviceCalibrationPlan, DeviceCalibrationPlanRespVO.class));
    }

    @GetMapping("/page")
    @Operation(summary = "获得设备-检定校准计划分页")
    public CommonResult<PageResult<DeviceCalibrationPlanRespVO>> getDeviceCalibrationPlanPage(@Valid DeviceCalibrationPlanPageReqVO pageReqVO) {
        PageResult<DeviceCalibrationPlanDO> pageResult = deviceCalibrationPlanService.getDeviceCalibrationPlanPage(pageReqVO);
        return success(BeanUtils.toBean(pageResult, DeviceCalibrationPlanRespVO.class));
    }

    @GetMapping("/export-excel")
    @Operation(summary = "导出设备-检定校准计划 Excel")
    @PreAuthorize("@ss.hasPermission('qms:device-calibration-plan:export')")
    @ApiAccessLog(operateType = EXPORT)
    public void exportDeviceCalibrationPlanExcel(@Valid DeviceCalibrationPlanPageReqVO pageReqVO,
              HttpServletResponse response) throws IOException {
        pageReqVO.setPageSize(PageParam.PAGE_SIZE_NONE);
        List<DeviceCalibrationPlanDO> list = deviceCalibrationPlanService.getDeviceCalibrationPlanPage(pageReqVO).getList();
        // 导出 Excel
        ExcelUtils.write(response, "设备-检定校准计划.xls", "数据", DeviceCalibrationPlanRespVO.class,
                        BeanUtils.toBean(list, DeviceCalibrationPlanRespVO.class));
    }

}